﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class GameController : MonoBehaviour {

    public static List<PlayerScript> players;
    public static List<AudioSource> soundEffects;
    public static List<GameObject> blobs;
    public List<PlayerScript> setPlayers;
    public List<AudioSource> setSoundEffects;
    public List<GameObject> setBlobs;

	public static PlayerScript playerWon;
	public static bool skip;
	public int skipCounter;

	public GUIStyle winStyle;

    public void Start()
    {
        players = this.setPlayers;
        soundEffects = this.setSoundEffects;
        blobs = setBlobs;
		playerWon=null;
		skip = false;
		skipCounter = 50;
    }

	public void Update(){
		if(skip){
			skipCounter-=1;
		}
		if(skipCounter<=0){
			if(Input.anyKey){
				Invoke("restartLevel", 2.0f);
			}

		}
	}

	public void OnGUI(){
		if(playerWon!=null){
			GUI.Label(new Rect(Screen.width/2-125,Screen.height/2-100,250,100), "player " + playerWon.playerNumber + " won! ", winStyle);
			GUI.Label(new Rect(Screen.width/2-125,Screen.height/2,200,200), playerWon.textures[0]);
		}
	}

    public static void ChangeColor(string targetColor, PlayerScript origin)
    {
        PlaySound("colorchange");
        for (int i = 0; i < players.Count; i++)
        {
            if (players[i].currentColor != targetColor)
            {
                players[i].ChangeColor(targetColor);

                if (players[i].playerNumber != origin.playerNumber)
                {
                    Vector3 pp = players[i].gameObject.transform.position;
                    GameObject blot = Instantiate(GetBlob(targetColor), new Vector3(pp.x, pp.y + 30, pp.z), Quaternion.identity) as GameObject;
                    blot.transform.localScale = new Vector3(.5f, .5f, .5f);

                    players[i].CreateChangeAnimation();
                }
            }
        }
    }

    public void OnDestroy()
    {
        XInputDotNetPure.GamePad.SetVibration(XInputDotNetPure.PlayerIndex.One, 0, 0);
        XInputDotNetPure.GamePad.SetVibration(XInputDotNetPure.PlayerIndex.Two, 0, 0);
        XInputDotNetPure.GamePad.SetVibration(XInputDotNetPure.PlayerIndex.Three, 0, 0);
        XInputDotNetPure.GamePad.SetVibration(XInputDotNetPure.PlayerIndex.Four, 0, 0);
    }

    public static string GetColorName(Color color)
    {
        float r = color.r;
        float g = color.g;
        float b = color.b;

        //if (r > 0.8f && r < 2f && g > -1f && g < 0.3f && b > -1f && b < 0.3f) return "red";
        if (r > -1f && r < 0.3f && g > 0.8f && g < 2f && b > -1f && b < 0.3f) return "green";
        if (r > -1f && r < 0.3f && g > -1f && g < 0.3f && b > 0.8f && b < 2f) return "blue";

        //Auto-generated
        if (r > -0.0140625f && r < 0.1859375f && g > 0.4390625f && g < 0.6390625f && b > 0.2320313f && b < 0.4320312f) return "mint";
        if (r > 0.7789062f && r < 0.9789063f && g > 0.1890625f && g < 0.3890625f && b > 0.005468749f && b < 0.2054687f) return "orange";
        if (r > 0.4664063f && r < 0.6664063f && g > 0.01328125f && g < 0.2132812f && b > 0.1226562f && b < 0.3226562f) return "purple";
        if (r > 0.8453125f && r < 1.045313f && g > 0.5367187f && g < 0.7367188f && b > -0.0375f && b < 0.1625f) return "yellow";


        return "white";
    }

    public static void PlaySound(string name)
    {
        for (int i = 0; i < soundEffects.Count; i++)
        {
            if (soundEffects[i].clip.name == name) soundEffects[i].Play();
        }
    }

    public static void ReplacePlayer(PlayerScript player)
    {
        int toRemove = -1;

        for (int i = 0; i < players.Count; i++)
        {
            if (players[i].playerNumber == player.playerNumber) toRemove = i;
        }

        if (toRemove != -1)
        {
            players.RemoveAt(toRemove);
            players.Add(player);
        }
    }

    public static GameObject GetBlob(string color)
    {
        for (int i = 0; i < blobs.Count; i++)
        {
            if (blobs[i].name.Contains(color)) return blobs[i];
        }
        return null;
    }

	public void restartLevel(){
		Application.LoadLevel(Application.loadedLevelName);
	}




	public static void PlayerDied(){
		int playersLeft = 4;
		PlayerScript player = null;

		for (int i = 0; i < players.Count; i++)
		{
			if (players[i].livesLeft > 0){
				player = players[i];
			}else{
				playersLeft-=1;
			}
		}

		if(playersLeft==1&&player!=null){
			playerWon = player;
			skip=true;
		}else{
			Debug.Log (playersLeft);
		}

	}
}
