﻿using UnityEngine;
using System.Collections;

public class playerBehaviour : MonoBehaviour {

	public int playerNum = 1;
	public float speed = 10.0F;
	public GameObject overLapAnim;
	public GameObject overLapAnim2;
	public GameObject overLapAnim3;
	public GameObject overLapAnim4;

	Texture2D background;
	Transform bgTrans;
	Transform thisTrans;
	Vector3 screenPos;
	Vector2 pixelUV;
	Camera renderCam;

	public Color color1 = new Color(0.9529F, 0.6392F, 0.0627F, 1.0F);
	public Color color2 = new Color(0.88627F, 0.2902F, 0.10588F, 1.0F);
	public Color color3 = new Color(0.08235F, 0.5412F, 0.3333F, 1.0F);
	public Color color4 = new Color(0.5647F, 0.1137F, 0.22745F, 1.0F);

	Color lastColor;
	Color currentColor;

	/*public Color color1Light = new Color(0.9529F, 0.6392F, 0.0627F, 1.0F);
	public Color color1Dark = new Color(0.9529F, 0.6392F, 0.0627F, 1.0F);

	public Color color2Light = new Color(0.88627F, 0.2902F, 0.10588F, 1.0F);
	public Color color2Dark = new Color(0.88627F, 0.2902F, 0.10588F, 1.0F);

	public Color color3Light = new Color(0.08235F, 0.5412F, 0.3333F, 1.0F);
	public Color color3Dark = new Color(0.08235F, 0.5412F, 0.3333F, 1.0F);

	public Color color4Light = new Color(0.5647F, 0.1137F, 0.22745F, 1.0F);
	public Color color4Dark = new Color(0.5647F, 0.1137F, 0.22745F, 1.0F);*/


	// Use this for initialization
	void Start () {
		thisTrans = gameObject.transform;
		renderCam = GameObject.Find("bg_renderCam").camera;
	}
	
	// Update is called once per frame
	void Update () {
		float translationY = Input.GetAxis("Vertical"+playerNum) * speed;
		float translationX = Input.GetAxis("Horizontal"+playerNum) * speed;
		translationY *= Time.deltaTime;
		translationX *= Time.deltaTime;
		transform.Translate(translationX, translationY, 0);
		RaycastHit hit;
		if (Physics.Raycast(thisTrans.position, Vector3.forward, out hit, 100.0F)){
			if(hit.collider.gameObject.layer == 8){
				pixelUV = hit.textureCoord;
				background = GetRTPixels(renderCam.targetTexture, pixelUV.x, pixelUV.y);
				currentColor = background.GetPixel(1, 1);
				//print (currentColor);
				if(lastColor != currentColor){
					lastColor = currentColor;
					GameObject overlap;
					if(cCloseTo(currentColor, color1)){
						overlap = Instantiate(overLapAnim, new Vector3(thisTrans.position.x, thisTrans.position.y+30, thisTrans.position.z), Quaternion.identity) as GameObject;
						overlap.transform.localScale = new Vector3(.5f, .5f, .5f);
					} else if(cCloseTo(currentColor, color2)){
						overlap = Instantiate(overLapAnim2, new Vector3(thisTrans.position.x, thisTrans.position.y+30, thisTrans.position.z), Quaternion.identity) as GameObject;
						overlap.transform.localScale = new Vector3(.5f, .5f, .5f);
					} else if(cCloseTo(currentColor, color3)){
						overlap = Instantiate(overLapAnim3, new Vector3(thisTrans.position.x, thisTrans.position.y+30, thisTrans.position.z), Quaternion.identity) as GameObject;
						overlap.transform.localScale = new Vector3(.5f, .5f, .5f);
					} else if(cCloseTo(currentColor, color4)){
						overlap = Instantiate(overLapAnim4, new Vector3(thisTrans.position.x, thisTrans.position.y+30, thisTrans.position.z), Quaternion.identity) as GameObject;
						overlap.transform.localScale = new Vector3(.5f, .5f, .5f);
					}
				}
			}
		}
	}

	bool cCloseTo(Color fromColorm, Color toColor){
		print (fromColorm.GetHashCode()+" | "+toColor.GetHashCode());
		if(fromColorm.GetHashCode() - toColor.GetHashCode() > -50000000 && fromColorm.GetHashCode() - toColor.GetHashCode() < 50000000){
			return true;
		} else {
			return false;
		}
	}

	Texture2D GetRTPixels(RenderTexture rt, float normalizedX, float normalizedY) {
		RenderTexture currentActiveRT = RenderTexture.active;
		RenderTexture.active = rt;
		Texture2D tex = new Texture2D(1, 1);
		tex.ReadPixels(new Rect(normalizedX*rt.width, normalizedY*rt.height, 1, 1), 0, 0);
		tex.Apply();
		 //Debug Texture to check color
		//GameObject.Find("debugPlane").renderer.material.mainTexture = tex;
		// 
		RenderTexture.active = currentActiveRT;
		return tex;
	}

}
